Package org.apache.commons.math3.analysis.solvers

# Interface BracketedRealFieldUnivariateSolver<T extends RealFieldElement<T>>

Type Parameters:
  `T` - the type of the field elements

All Known Implementing Classes:
  `BracketingNthOrderBrentSolverDFP`, `FieldBracketingNthOrderBrentSolver`

public interface BracketedRealFieldUnivariateSolver<T extends RealFieldElement<T>>
Interface for `(univariate real) root-finding algorithms` that maintain a bracketed solution. There are several advantages to having such root-finding algorithms:

- The bracketed solution guarantees that the root is kept within the interval. As such, these algorithms generally also guarantee convergence.
- The bracketed solution means that we have the opportunity to only return roots that are greater than or equal to the actual root, or are less than or equal to the actual root. That is, we can control whether under-approximations and over-approximations are `allowed solutions`. Other root-finding algorithms can usually only guarantee that the solution (the root that was found) is around the actual root.

For backwards compatibility, all root-finding algorithms must have `ANY_SIDE` as default for the allowed solutions.

Since:
  3.6
See Also:
  - `AllowedSolution`

## Method Summary

Modifier and Type
Method
Description
`T`
`getAbsoluteAccuracy()`
Get the absolute accuracy of the solver.
`int`
`getEvaluations()`
Get the number of evaluations of the objective function.
`T`
`getFunctionValueAccuracy()`
Get the function value accuracy of the solver.
`int`
`getMaxEvaluations()`
Get the maximum number of function evaluations.
`T`
`getRelativeAccuracy()`
Get the relative accuracy of the solver.
`T`
`solve(int maxEval, RealFieldUnivariateFunction<T> f, T min, T max, AllowedSolution allowedSolution)`
Solve for a zero in the given interval.
`T`
`solve(int maxEval, RealFieldUnivariateFunction<T> f, T min, T max, T startValue, AllowedSolution allowedSolution)`
Solve for a zero in the given interval, start at `startValue`.

## Method Details

### getMaxEvaluations

int getMaxEvaluations()
Get the maximum number of function evaluations.

Returns:
  the maximum number of function evaluations.

### getEvaluations

int getEvaluations()
Get the number of evaluations of the objective function. The number of evaluations corresponds to the last call to the `optimize` method. It is 0 if the method has not been called yet.

Returns:
  the number of evaluations of the objective function.

### getAbsoluteAccuracy

T getAbsoluteAccuracy()
Get the absolute accuracy of the solver. Solutions returned by the solver should be accurate to this tolerance, i.e., if ε is the absolute accuracy of the solver and `v` is a value returned by one of the `solve` methods, then a root of the function should exist somewhere in the interval (`v` - ε, `v` + ε).

Returns:
  the absolute accuracy.

### getRelativeAccuracy

T getRelativeAccuracy()
Get the relative accuracy of the solver. The contract for relative accuracy is the same as `getAbsoluteAccuracy()`, but using relative, rather than absolute error. If ρ is the relative accuracy configured for a solver and `v` is a value returned, then a root of the function should exist somewhere in the interval (`v` - ρ `v`, `v` + ρ `v`).

Returns:
  the relative accuracy.

### getFunctionValueAccuracy

T getFunctionValueAccuracy()
Get the function value accuracy of the solver. If `v` is a value returned by the solver for a function `f`, then by contract, `|f(v)|` should be less than or equal to the function value accuracy configured for the solver.

Returns:
  the function value accuracy.

### solve

T solve(int maxEval, RealFieldUnivariateFunction<T> f, T min, T max, AllowedSolution allowedSolution)
Solve for a zero in the given interval. A solver may require that the interval brackets a single zero root. Solvers that do require bracketing should be able to handle the case where one of the endpoints is itself a root.

Parameters:
  `maxEval` - Maximum number of evaluations.
  `f` - Function to solve.
  `min` - Lower bound for the interval.
  `max` - Upper bound for the interval.
  `allowedSolution` - The kind of solutions that the root-finding algorithm may accept as solutions.
Returns:
  A value where the function is zero.
Throws:
  `MathIllegalArgumentException` - if the arguments do not satisfy the requirements specified by the solver.
  `TooManyEvaluationsException` - if the allowed number of evaluations is exceeded.

### solve

T solve(int maxEval, RealFieldUnivariateFunction<T> f, T min, T max, T startValue, AllowedSolution allowedSolution)
Solve for a zero in the given interval, start at `startValue`. A solver may require that the interval brackets a single zero root. Solvers that do require bracketing should be able to handle the case where one of the endpoints is itself a root.

Parameters:
  `maxEval` - Maximum number of evaluations.
  `f` - Function to solve.
  `min` - Lower bound for the interval.
  `max` - Upper bound for the interval.
  `startValue` - Start value to use.
  `allowedSolution` - The kind of solutions that the root-finding algorithm may accept as solutions.
Returns:
  A value where the function is zero.
Throws:
  `MathIllegalArgumentException` - if the arguments do not satisfy the requirements specified by the solver.
  `TooManyEvaluationsException` - if the allowed number of evaluations is exceeded.